dnl
dnl $Header: /usr/local/libdata/cvs/simons/petidomo/aclocal.m4,v 1.7 1998/08/16 20:56:40 simons Exp $
dnl
dnl Local additions to Autoconf macros.
dnl

dnl
dnl Get the absolute path of the top source directory. Unfortunately
dnl the @top_src@ variable always gives the relative path, what is not
dnl what I need.

AC_DEFUN(PETI_PATH_SRCDIR, [
AC_MSG_CHECKING(path of top source directory)
SRCDIR=`(cd $srcdir;pwd)`
AC_MSG_RESULT($SRCDIR)
AC_SUBST(SRCDIR)
])

dnl
dnl This macro will define an user-specified option of the name
dnl "--with-dmalloc". If this is set to "yes" in some way, then the
dnl macro will add the appropriate defines to LIBS, CPPFLAGS and
dnl LDFLAGS so that the dmalloc library is compiled to the binary.

AC_DEFUN(PETI_WITH_DMALLOC, [
AC_MSG_CHECKING(whether to dmalloc library)
AC_ARG_WITH(dmalloc,
[  --with-dmalloc[=ARG]    Compile with dmalloc library],
if test "$withval" = "" -o "$withval" = "yes"; then
    ac_cv_dmalloc="/usr/local"
else
    ac_cv_dmalloc="$withval"
fi
AC_MSG_RESULT(yes)
CPPFLAGS="$CPPFLAGS -DDEBUG_DMALLOC -DDMALLOC_FUNC_CHECK -I$ac_cv_dmalloc/include"
LDFLAGS="$LDFLAGS -L$ac_cv_dmalloc/lib"
LIBS="$LIBS -ldmalloc"
,AC_MSG_RESULT(no))
])


dnl
dnl Give the user a way to add "-static" to the linker flags in a
dnl convenient way.

AC_DEFUN(PETI_ENABLED_DYNAMIC_LINK, [
AC_MSG_CHECKING(whether what binaries we shall create)
AC_ARG_ENABLE(dynamic-link,
[  --enable-dynamic-link   Create dynamically linked binaries (default)],
if test "$enableval" = "yes"; then
    AC_MSG_RESULT(dynamically linked)
else
    LDFLAGS="$LDFLAGS -static"
    AC_MSG_RESULT(statically linked)
fi,
AC_MSG_RESULT(dynamically linked))
])


dnl
dnl On some systems, the regular expression implementation is not as
dnl you'd expect. It is hard to say what the problem is in detail, but
dnl the result is definite: Petidomo does not work. Most notably this
dnl is the case on Solaris and old SunOS versions.
dnl
dnl Hence I provide my own regular expression implementation, which
dnl can be activated with this command line switch.

AC_DEFUN(PETI_WITH_MY_REGEX, [
MY_REGEX_LIB=
AC_SUBST(MY_REGEX_INC)
AC_SUBST(MY_REGEX_LIB)
AC_ARG_WITH(my-regex,
[  --with-my-regex[=ARG]   Compile with our own regex implementation],
AC_MSG_CHECKING(whether to use my own regex library)
if test "$withval" = "" -o "$withval" = "yes"; then
    MY_REGEX_LIB=libregex.a
    MY_REGEX_INC=regex.h
    LIBS="$LIBS -lregex"
    AC_MSG_RESULT(yes)
else
    AC_MSG_RESULT(no)
fi
,[
AC_CHECK_FUNC(regcomp, , [
    AC_MSG_RESULT(Using my own regex library.)
    MY_REGEX_LIB=libregex.a
    MY_REGEX_INC=regex.h
    LIBS="$LIBS -lregex"
])
])
])

