/*
 *      $Source: /usr/local/libdata/cvs/simons/petidomo/include/debug.h,v $
 *      $Revision: 1.8 $
 *      $Date: 1997/12/09 21:23:17 $
 *
 *      Copyright (C) 1997 by Peter Simons, Germany
 *      All rights reserved.
 */

#ifndef __DEBUG_H__
#define __DEBUG_H__ 1

/********** Known debug modules. **********/

enum {
    DEBUG_MAIN,
    DEBUG_COMMAND,
    DEBUG_LISTSERV,
    DEBUG_HERMES,
    DEBUG_CONFIG,
    DEBUG_RFCPARSE,
    DEBUG_MAILER,
    DEBUG_ACL,
    DEBUG_AUTHEN,
    DEBUG_FILTER,
    DEBUG_ARCHIVE,
    DEBUG_EOL
};

#define MODULE_TABLE const char * const ModuleTable[] = { \
    "main", \
    "command", \
    "listserv", \
    "hermes", \
    "config", \
    "rfcparse", \
    "mailer", \
    "acl", \
    "authen", \
    "filter", \
    "archive", \
     NULL };

/********** Prototypes **********/

#ifdef DEBUG
void setDebugLevel(unsigned int, unsigned int);
unsigned int getDebugLevel(unsigned int);
void _debug(unsigned int, unsigned int, const char *, ...);
#  define debug(x) _debug x;
#else
#  define setDebugLevel(a,b) ;
#  define debug(x) ;
#endif

#endif /* !__DEBUG_H__ */
