/*
 *      $Source: /usr/local/libdata/cvs/c-lib/libdebug/test.c,v $
 *      $Revision: 1.2 $
 *      $Date: 1997/12/09 14:22:09 $
 *
 *      Copyright (C) 1997 by Peter Simons, Germany
 *      All rights reserved.
 */

#include <stdio.h>
#include <syslog.h>
#ifndef LOG_PERROR
#  define LOG_PERROR 0
#endif

/********** Required init stuff for the debug library. **********/

/*
   The following sections will normally be located in a debug.h
   include file, which the user of the library provides for his/her
   project.
 */

enum {
    DEBUG_LIB,
    DEBUG_MAIN,
    DEBUG_TEST,
    /* add more modules here */
    DEBUG_EOL
};

#ifdef DEBUG
void setDebugLevel(unsigned int, unsigned int);
unsigned int getDebugLevel(unsigned int);
void _debug(unsigned int, unsigned int, const char *, ...);
#  define debug(x) _debug x;
#else
#  define setDebugLevel(a,b) ;
#  define debug(x) ;
#endif


/********** Main program **********/

int
main(int argc, char ** argv)
{
    openlog("libdebug-test", LOG_PID | LOG_PERROR, LOG_USER);

    setDebugLevel(DEBUG_MAIN, 3);
    debug((DEBUG_MAIN, 2, "testing the %s.", "library"));
    debug((DEBUG_MAIN, 4, "This ain't coming through."));
    debug((DEBUG_LIB, 4, "Neither this."));
    setDebugLevel(DEBUG_LIB, 1);
    debug((DEBUG_LIB, 4, "Nope!"));
    debug((DEBUG_LIB, 1, "Hi!"));

    return 0;
}
