/*
 *      $Source: /usr/local/libdata/cvs/simons/petidomo/src/htmlconf/handlemainpage.c,v $
 *      $Revision: 1.9 $
 *      $Date: 1998/06/01 21:36:42 $
 *
 *      Copyright (C) 1996 by Peter Simons, Germany
 *      All rights reserved.
 */

#include <cgi.h>
#include <petidomo.h>

extern cgi_info      ci;
extern form_entry *  form_parameter;

void printMainPage(void);
void genListIndex(void);
void printNewList(void);
void printRemList(void);

const char petidomo_conf_html[] = \
"<H1 ALIGN=CENTER>Petidomo 2.2 Main Configuration</H1>\n" \
\
"<FORM METHOD=\"POST\" ACTION=\"%s\">\n" \
"<INPUT TYPE=hidden NAME=page VALUE=conf>\n" \
"<INPUT TYPE=hidden NAME=password VALUE=\"%s\">\n" \
\
"Please specify the <STRONG>fully qualified host name</STRONG> of the\n" \
"machine Petidomo is running on: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"Hostname\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Here you can specify a new <STRONG>master password</STRONG> for\n" \
"Petidomo. Leave the input field blank, if you don't want to change the\n" \
"password: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"newpassword\" SIZE=30 VALUE=\"\">\n" \
"</CENTER>\n" \
\
"Please enter the same password again, to make sure you spelled it\n" \
"correctly: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"newpassword2\" SIZE=30 VALUE=\"\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please enter the complete path to the <STRONG>sendmail\n" \
"program</STRONG> Petidomo should use to deliver the outgoing\n" \
"electronic mail: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"mta\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
\
"Please enter the <STRONG>options</STRONG>, Petidomo should use when\n" \
"executing the <STRONG>sendmail program</STRONG> above: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"mta_options\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <BR>\n" \
\
"Please note that the string '%%s' will be replaced with the envelope,\n" \
"the outgoing mail will be sent under, and <EM>must</EM> be present in\n" \
"the options string you specify here, or Petidomo will terminate with\n" \
"an error.  <P>\n" \
\
"You will usually <EM>not</EM> have to modify the default setting. <P>\n" \
\
"<HR> <P>\n" \
\
"Please choose whether you want Petidomo to run in in\n" \
"<STRONG>syncronous or asyncronous mode</STRONG>: <BR>\n" \
\
"<CENTER>\n" \
"<TABLE>\n" \
"  <TR><TD><INPUT TYPE=radio NAME=detachimmediately VALUE=no %s> syncronous mode </TR>\n" \
"  <TR><TD><INPUT TYPE=radio NAME=detachimmediately VALUE=yes %s> asyncronous mode </TR>\n" \
"</TABLE>\n" \
"</CENTER> <BR>\n" \
\
"In syncronous mode, Petidomo will process the mail completely,\n" \
"before it terminates. Hence, the SMTP daemon has to wait until the\n" \
"whole mail is processed, before it can terminate itself. This may\n" \
"cause memory problems at high-load servers, where several dozen, or\n" \
"even hundreds of emails can arrive at the same time. <P>\n" \
\
"In asyncronous mode, Petidomo will read the mail and then detach\n" \
"itself. The advantage is that the SMTP daemon can terminate\n" \
"immediately and doesn't have to wait until Petidomo is finished\n" \
"processing the mail. The disadvantage is that in case of an error,\n" \
"the SMTP daemon will not receive the return code from Petidomo. For\n" \
"smaller servers, syncronous mode is recommended -- larger servers\n" \
"should use asyncronous mode. <P>\n" \
\
"<HR> <P>\n" \
\
"Please choose whether you want Petidomo to generate\n" \
"<STRONG>run-time statistics</STRONG>: <BR>\n" \
\
"<CENTER>\n" \
"<TABLE>\n" \
"  <TR><TD><INPUT TYPE=radio NAME=showstats VALUE=yes %s> Yes </TR>\n" \
"  <TR><TD><INPUT TYPE=radio NAME=showstats VALUE=no %s> No </TR>\n" \
"</TABLE>\n" \
"</CENTER> <BR>\n" \
\
"When Petidomo processes a request such as SUBSCRIBE or INDEX, it will\n" \
"append some statistics at the end of the mail, like the CPU time it\n" \
"required to process the command or the amount of memory the Petidomo\n" \
"process needed. In the commercial version, this setting can be\n" \
"disabled with this switch.<p>\n" \
\
"<HR> <P>\n" \
"<INPUT TYPE=\"submit\"> <INPUT TYPE=\"reset\">\n" \
"</FORM>\n" \
"</BODY>\n" \
"</HTML>\n";


void
handleMainPage(void)
{
    const struct PD_Config * MasterConfig = getMasterConfig();
    char *   configaction;
    char *   password;

    /* Determine what the user intended to do. */

    configaction = parmval(form_parameter, "configaction");
    password = parmval(form_parameter, "password");

    /* Do sanity checks. */

    if (configaction == NULL || password == NULL) {
	printMainPage();
	return;
    }

    if (!strcasecmp(configaction, "confmain")) {
	if (isValidAdminPassword(password, NULL) == TRUE) {
	    printf(petidomo_conf_html, ci.script_name, password,
		   MasterConfig->fqdn, MasterConfig->mta, MasterConfig->mta_options,
		   ((MasterConfig->detach == FALSE) ? "CHECKED" : ""),
		   ((MasterConfig->detach == TRUE) ? "CHECKED" : ""),
		   ((MasterConfig->show_stats == TRUE) ? "CHECKED" : ""),
		   ((MasterConfig->show_stats == FALSE) ? "CHECKED" : ""));
	}
	else {
	    puts("<H1 ALIGN=center>Access denied!</H1>");
	    puts("The password you entered doesn't authorize you to edit the main");
	    puts("configuration, I am afraid.");
	}
    }
    else if (!strcasecmp(configaction, "conflist")) {
	genListIndex();
    }
    else if (!strcasecmp(configaction, "newlist")) {
	printNewList();
    }
    else if (!strcasecmp(configaction, "remlist")) {
	printRemList();
    }
    else {
	puts("An internal error occured in handleMainPage(). Please contact");
	puts("<A HREF=\"mailto:simons@petidomo.com\">Peter Simons</A> about this.");
    }
}
